package com.huimv.produce.produce.controller;


import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.produce.produce.entity.ProdProduce;
import com.huimv.produce.produce.service.IProdProduceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author astupidcoder
 * @since 2021-11-25
 */
@RestController
@RequestMapping("/prodProduce")
public class ProdProduceController {

    @Autowired
    private IProdProduceService prodProduceService;

    @GetMapping("/listProducee")
    public Result listProducee(@RequestParam(name = "farmId") Integer farmId){
        Date now = new Date();
        List<ProdProduce> list = prodProduceService.list(new QueryWrapper<ProdProduce>().eq("farm_id", farmId).eq("year", DateUtil.year(now)).eq("month", DateUtil.month(now)+1));
        Map map = new HashMap();
        for (ProdProduce prodProduce : list) {
            String stockType = prodProduce.getStockType();
            map.put(stockType,prodProduce);
        }
        return new Result(ResultCode.SUCCESS,map);
    }

    @PostMapping("/listImportance")
    public Result listImportance(@RequestBody Map<String, String> map){

        return prodProduceService.listImportance(map);
    }
}
